unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ExtCtrls, ComCtrls, Parts, iClip;

type
  TMainForm = class(TForm)
    PnlKeyword: TPanel;
    Edit1: TEdit;
    ListLemma: TListBox;
    MainMenu: TMainMenu;
    MenuConfig: TMenuItem;
    MenuForceIndex: TMenuItem;
    MenuHelp: TMenuItem;
    MenuVersion: TMenuItem;
    MenuFile: TMenuItem;
    MenuOpenEdict: TMenuItem;
    MenuAutoOpenEdict: TMenuItem;
    StatusBar: TStatusBar;
    Panel2: TPanel;
    PaintBox1: TPaintBox;
    MenuClipWatch: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListLemmaData(Control: TWinControl; Index: Integer; var Data: String);
    procedure Edit1Change(Sender: TObject);
    procedure MenuVersionClick(Sender: TObject);
    procedure MenuOpenEdictClick(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure MenuClipWatchClick(Sender: TObject);
  private
    FEdict: TEdict;
    FCounter: TCounter;
  private
    FWatcher: TClipWatcher;
    procedure ClipUpdatedNotify();
  public

  end;

var
  MainForm: TMainForm;

implementation

uses
    ClipBrd, jeuc, Info;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  o[W
procedure TMainForm.MenuVersionClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
//  N
procedure TMainForm.FormCreate(Sender: TObject);
begin
    SetFormCaption(Self);
    FCounter := TCounter.Create();
    FWatcher := TClipWatcher.Create(ClipUpdatedNotify);
    FEdict := TEdict.Create();
    LoadPropertyFromFile(ChangeFileExt(ParamStr(0), '.ini'), Self);
    MenuClipWatch.OnClick(MenuClipWatch);
end;

//-----------------------------------------------------------------------------
//  \
procedure TMainForm.PaintBox1Paint(Sender: TObject);
begin
    Panel2.Hide();
    PaintBox1.OnPaint := nil;
    if (MenuAutoOpenEdict.Checked) then
    begin
        MenuOpenEdictClick(nil);
    end;
    Self.Repaint();
end;

//-----------------------------------------------------------------------------
//  I
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    FEdict.Free();
    FWatcher.Free();
    FCounter.Free();

    SavePropertyToFile(ChangeFileExt(ParamStr(0), '.ini'), Self);
end;

//-----------------------------------------------------------------------------
//  f[^ǂݍ
procedure TMainForm.MenuOpenEdictClick(Sender: TObject);
begin
    Screen.Cursor := crHourGlass;
    StatusBar.Panels[0].Text := 'Wait a minute';
    StatusBar.Repaint();
    FCounter.Enter();
    ListLemma.Count := FEdict.LoadEdict('edict.gz', MenuForceIndex.Checked);
    StatusBar.Panels[1].Text := FEdict.EdictPath;
    StatusBar.Panels[2].Text := FEdict.IndexPath;
    StatusBar.Panels[3].Text := Format('%d[ms]', [FCounter.Leave()]);
    StatusBar.Panels[0].Text := 'Loaded';
    Screen.Cursor := crDefault;

    if (ListLemma.Count = 0) then
    begin
        AppMessageBox(
            'edict t@ClbgŒTĂăvOƓtH_ɓĂȁB',
            Application.Title, MB_OK or MB_ICONINFORMATION
            );
    end;

    Edit1.Hint := Edit1.Text;
    Edit1.Text := '';
    Edit1.Text := Edit1.Hint;
    Edit1.Hint := '';
end;

//-----------------------------------------------------------------------------
//  Xg{bNXɕ\f[^o
procedure TMainForm.ListLemmaData(Control: TWinControl; Index: Integer; var Data: String);
begin
    Data := FEdict.GetLineData(Index);
end;

//-----------------------------------------------------------------------------
//  {bNXύX
procedure TMainForm.Edit1Change(Sender: TObject);
begin
    ListLemma.TopIndex := FEdict.ForwardSearch(Edit1.Text);
    ListLemma.ItemIndex := ListLemma.TopIndex;
end;

//-----------------------------------------------------------------------------
//  Nbv{[hĎ
procedure TMainForm.ClipUpdatedNotify();
begin
    if (MenuClipWatch.Checked and Clipboard.HasFormat(CF_TEXT)) then
    begin
        Edit1.Text := Clipboard.AsText;
        SetForegroundWindow(Application.Handle);
    end;
end;

//-----------------------------------------------------------------------------
//  Nbv{[hĎݒ
procedure TMainForm.MenuClipWatchClick(Sender: TObject);
begin
    PnlKeyword.Enabled := not MenuClipWatch.Checked;
end;

end.
