//  () ̋؂~XĂ

unit Parts;

interface

uses
    Windows, SysUtils, Classes, Menus, Contnrs, IniFiles, jeuc;

type
    //  g[N؂oNX
    TEdictTokenizer = class
    private
        FText: String;
        FPos: Integer;
        FLen: Integer;
    public
        //  RXgN^
        constructor Create();
        //  fXgN^
        destructor Destroy(); override;
        //  
        procedure Reset(const Str: String);
        //  g[N擾
        function Next(): String;
    end;

    //  Ԍv(蔲)
    TCounter = class
    private
        FEnterTick: Cardinal;
    public
        procedure Enter();
        function Leave(): Cardinal;
    end;

type
    //  f[^ǗNX
    TEdict = class
    private
        //  f[^̃pX
        FEdictPath: String;
        FIndexPath: String;
        //  o
        FLemma: TStringList;
        //  ʒu񃊃Xg
        FEntryPos: TObjectList;
        //  t@Cǂݍ
        FEdict: TFileStream;
    private
        //  ͂oꃊXg
        FIgnoreList: TStringList;
        //  ͂Xg쐬
        procedure BuildIgnoreList();
        //  ͂H
        function IsIgnoreToken(const AToken: String): Boolean;
    public
        //  RXgN^
        constructor Create();
        //  fXgN^
        destructor Destroy(); override;
        //  NA
        procedure Clear();
        //  f[^猩oꃊXg쐬
        function LoadEdict(const AEdictPath: String; const AForcedIndex: Boolean): Integer;
    public
        //  o̐
        function GetLemmaCount(): Integer;
        //  sf[^擾
        function GetLineData(const AIndex: Integer): String;
        //  Ov
        function ForwardSearch(const AText: String): Integer;
    public
        property EdictPath: String read FEdictPath;
        property IndexPath: String read FIndexPath;
    end;

const
    ADD_RATE = 1000;
    LEN_OFFGTH = 11;

type
  TModParts = class(TDataModule)
  private

  public

  end;

var
  ModParts: TModParts;

implementation

uses
    Info;

{$R *.dfm}


//-----------------------------------------------------------------------------
constructor TEdict.Create();
begin
    FIgnoreList := THashedStringList.Create();
    FIgnoreList.Sorted := True;
    FIgnoreList.Duplicates := dupIgnore;
    BuildIgnoreList();

    //  𑬂
    //FLemma := TStringList.Create();
    FLemma := THashedStringList.Create();
    //  ǉ̓xɃ\[gƂ
    //FLemma.Sorted := True;

    FEntryPos := TObjectList.Create(True);
    Clear();
end;

//-----------------------------------------------------------------------------
destructor TEdict.Destroy();
begin
    Clear();
    FIgnoreList.Free();
    FLemma.Free();
    FEntryPos.Free();
end;

//-----------------------------------------------------------------------------
procedure TEdict.Clear();
begin
    FLemma.Clear();
    FLemma.Sorted := False;
    FEntryPos.Clear();
    FEdict.Free();
    FEdict := nil;
end;

//-----------------------------------------------------------------------------
procedure TEdict.BuildIgnoreList();
begin
    FIgnoreList.Add('is');
    FIgnoreList.Add('am');
    FIgnoreList.Add('be');
    FIgnoreList.Add('are');

    FIgnoreList.Add('an');
    FIgnoreList.Add('the');

    FIgnoreList.Add('in');
    FIgnoreList.Add('at');
    FIgnoreList.Add('of');
    FIgnoreList.Add('on');
    FIgnoreList.Add('with');
    FIgnoreList.Add('by');
    FIgnoreList.Add('for');
    FIgnoreList.Add('to');

    FIgnoreList.Add('not');

    FIgnoreList.Add('and');
    FIgnoreList.Add('or');

    FIgnoreList.Add('..');
    FIgnoreList.Add('...');
    FIgnoreList.Add('....');
    FIgnoreList.Add('.....');
    FIgnoreList.Add('...?');
end;

//-----------------------------------------------------------------------------
function TEdict.IsIgnoreToken(const AToken: String): Boolean;
var
    LDummy: Integer;
begin
    Result := (FIgnoreList.Find(AToken, LDummy))
           or (Length(AToken) = 1)
           or TryStrToInt(AToken, LDummy)
           ;
end;

//-----------------------------------------------------------------------------
function TEdict.LoadEdict(const AEdictPath: String; const AForcedIndex: Boolean): Integer;
var
    LTokenizer: TEdictTokenizer;
    LToken: String;
var
    LBuf: TStringList;
    i: Integer;
    LLine: String;
    LOffset: Int64;
    LLength: Integer;
    LOffGth: Int64;
    LOL: String;
    LTokenOL: String;
    LTokenLen: Integer;
    LIndexBuf: TFileStream;
begin
    FEdictPath := AEdictPath;
    FIndexPath := ChangeFileExt(FEdictPath, '.index');
    Clear();

    if (FileExists(FEdictPath)) then
    begin
        try
            //  CfbNXt@C쐬
            if (AForcedIndex or (not FileExists(FIndexPath))) then
            begin
                LTokenizer := nil;
                LBuf := nil;
                LIndexBuf := nil;
                try
                    //  CfbNX͂t@Cɏo
                    LIndexBuf := TFileStream.Create(FIndexPath, fmCreate or fmShareExclusive);

                    //  f[^ǂݍ
                    LBuf := TStringList.Create();
                    LBuf.LoadFromFile(FEdictPath);
                    LOffset := 0;

                    //  o擾p
                    LTokenizer := TEdictTokenizer.Create();

                    //  oEʒȗgݍ킹ŌXg쐬
                    for i := 0 to LBuf.Count - 1 do
                    begin
                        //  1so
                        LLine := LBuf[i];
                        //  f[^({ƉsR[h)
                        LLength := Length(LLine) + 1;

                        //  ItZbgƒ𕶎
                        LOffGth := LOffset * ADD_RATE + LLength;
                        LOL := Format('%11.11d'#13#10, [LOffGth]);

                        //  o擾
                        LTokenizer.Reset(EUCtoSJIS_String(LLine));
                        LToken := LTokenizer.Next();
                        while (LToken <> '') do
                        begin
                            if (not IsIgnoreToken(LToken)) then
                            begin
                                //  ̑Z񐔂炷(2008/05/22)
                                //FLemma.Add(LToken + LOL);
                                LTokenLen := Length(LToken);
                                SetLength(LTokenOL, LTokenLen + 13);
                                System.Move(LToken[1], LTokenOL[1], LTokenLen);
                                System.Move(LOL[1], LTokenOL[LTokenLen + 1], 13);
                                //FLemma.Add(LTokenOL);
                                LIndexBuf.Write(LTokenOL[1], LTokenLen + 13);
                            end;
                            LToken := LTokenizer.Next();
                        end;

                        //  Ŝ̒ł̃ItZbg
                        Inc(LOffset, LLength);
                    end;
                finally
                    LBuf.Free();
                    LTokenizer.Free();
                    LIndexBuf.Free();
                end;

                //  CfbNXt@C\[g
                if (FileExists(FIndexPath)) then
                begin
                    LBuf := nil;
                    try
                        LBuf := TStringList.Create();
                        //  CfbNXt@Cǂݍ
                        LBuf.LoadFromFile(FIndexPath);
                        //  \[g
                        LBuf.Sorted := True;
                        //  CfbNXt@Cۑ
                        LBuf.SaveToFile(FIndexPath);
                    finally
                        LBuf.Free();
                    end;
                end;
            end;

            //  CfbNXt@Cǂݍ
            FLemma.LoadFromFile(FIndexPath);
            //  ǂݍ񂾌Ń\[g(dupIgnoregȂ...)
            //FLemma.Sorted := True;

            //  t@Cǂݍ
            FEdict := TFileStream.Create(FEdictPath, fmOpenRead or fmShareDenyNone);
        except
        end;
    end;

    //  o̐߂
    Result := FLemma.Count;
end;

//-----------------------------------------------------------------------------
function TEdict.GetLemmaCount(): Integer;
begin
    Result := FLemma.Count;
end;

//-----------------------------------------------------------------------------
function TEdict.GetLineData(const AIndex: Integer): String;
var
    LLine: String;
    LOL: String;
    LOffGth: Int64;
    LOffset: Integer;                   
    LLength: Integer;
    LReadLen: Integer;
begin
    if (0 <= AIndex) and (AIndex < FLemma.Count) then
    begin
        LLine := FLemma[AIndex];
        LOL := Copy(LLine, Length(LLine) - 10, 11);
        LOffGth := StrToInt64Def(LOL, 0);
        LOffset := LOffGth div ADD_RATE;
        LLength := LOffGth mod ADD_RATE;
        FEdict.Seek(LOffset, soFromBeginning);
        SetLength(LLine, LLength);
        LReadLen := FEdict.Read(LLine[1], LLength);
        SetLength(LLine, LReadLen);
        Result := EUCtoSJIS_String(LLine);
    end
    else
    begin
        Result := '';
    end;
end;

//-----------------------------------------------------------------------------
function TEdict.ForwardSearch(const AText: String): Integer;
begin
    FLemma.Find(AText, Result);
end;

//=============================================================================
//  TEdictTokenizer
//=============================================================================

//-----------------------------------------------------------------------------
constructor TEdictTokenizer.Create();
begin
    inherited;
end;

//-----------------------------------------------------------------------------
destructor TEdictTokenizer.Destroy();
begin
    inherited;
end;


//-----------------------------------------------------------------------------
procedure TEdictTokenizer.Reset(const Str: String);
begin
    FText := Str;
    FPos := 1;
    FLen := Length(Str);
end;

//-----------------------------------------------------------------------------
//  EDICT (Ver.1) ̃tH[}bg
//  KANJI [KANA] /(general information) gloss/gloss/.../
//  KANA /(general information) gloss/gloss/.../
function TEdictTokenizer.Next(): String;
var
    LTokenStart: Integer;
    LTokenLen: Integer;
    LChar: Char;
    LInRoundBracket: Boolean;
begin
    Result := '';
    LTokenStart := FPos;
    LTokenLen := 0;
    LInRoundBracket := False;

    while (FPos <= FLen) do
    begin
        LChar := FText[FPos];
        //  2oCg
        if (IsDBCSLeadByte(Byte(LChar))) then
        begin
            Inc(FPos);
        end
        //  ȊO
        else
        begin
            case LChar of
            ' ', '/', '"':
                begin
                    //  擪ȂXLbv
                    if (FPos = LTokenStart) then
                    begin
                        Inc(LTokenStart);
                    end
                    //  rȂ؂(܂ł Token)
                    else
                    begin
                        LTokenLen := FPos - LTokenStart;
                        Inc(FPos);
                        Break;
                    end;
                end;
            '[':
                begin
                    //  擪 [ ̓XLbv(Token ̎n܂)
                    Inc(LTokenStart);
                end;
            ']', ',':
                begin
                    //  ؂(܂ł Token)
                    //  ], ̂̓XLbv
                    LTokenLen := FPos - LTokenStart;
                    Inc(FPos);
                    Break;
                end;
            '(':
                begin
                    //  擪Ȃȍ~ ) ܂ŃXLbv
                    if (FPos = LTokenStart) then
                    begin
                        LInRoundBracket := True;
                        Inc(LTokenStart);
                    end;
                end;
            ')':
                begin
                    //  ܂ŃXLbv
                    LInRoundBracket := False;
                    Inc(LTokenStart);
                end;
            else
                begin
                    //  ʓȂXLbv
                    if (LInRoundBracket) then
                    begin
                        Inc(LTokenStart);
                    end;
                end;
            end;
        end;
        //  ݈ʒui߂
        Inc(FPos);
    end;

    //  Token ؂o
    //  Copy ֐gȂ(2008/05/22)
    //Result := Copy(FText, LTokenStart, LTokenLen);
    if (LTokenLen > 0) then
    begin
        SetLength(Result, LTokenLen);
        System.Move(FText[LTokenStart], Result[1], LTokenLen);
    end;
end;

//=============================================================================
//  TCounter
//=============================================================================

//-----------------------------------------------------------------------------
procedure TCounter.Enter();
begin
    FEnterTick := GetTickCount();
end;

//-----------------------------------------------------------------------------
function TCounter.Leave(): Cardinal;
begin
    Result := GetTickCount() - FEnterTick;
end;

end.
