(*
    ############################################################################

    Nbv{[hĎNX

    http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0210.txt
    http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0209.txt


    AvP[V̓\to

    http://hp.vector.co.jp/authors/VA003525/tips21.htm

    ############################################################################
*)

unit iClip;

interface

uses
    Windows, Messages, SysUtils, Classes, ClipBrd;


type
    // ύXʒm֐
    TClipUpdatedNotify = procedure() of object;
//    TClipUpdatedNotify = procedure();

    // ύXĎNX
    TClipWatcher = class

    private
        IsFirst     : Boolean;

        WndHandle   : THandle;
        HClipNext   : HWND;
        ClipProc    : TClipUpdatedNotify;
        procedure   ClipboardSetHandle;
        procedure   ClipboardReleaseHandle;
        procedure   WndProc(var Msg: TMessage);
    public
        constructor Create(Proc: TClipUpdatedNotify);
        destructor  Destroy(); override;

    end;

    // ύXʒm֐
    TDerayRenderer = procedure() of object;
//    TDerayRenderer = procedure();

    // \tĎNX
    TPasteWatcher = class

    private
        WndHandle   : THandle;
        RenderProc  : TDerayRenderer;
        procedure   WndProc(var Msg: TMessage);
    public
        procedure	SetRender;
        constructor Create(Proc: TDerayRenderer);
        destructor  Destroy(); override;

    end;

function	ClipFormatStr(Value: Integer): String;

implementation

//uses
//    Dialogs;  // eXgR[hp

(*
    ############################################################################

    Utility

    ############################################################################
*)

(*
	=======================================================
    Nbv{[h̃tH[}bg
	=======================================================
*)
function	ClipFormatStr(Value: Integer): String;
begin
    case Value of
        CF_TEXT			: Result := 'CF_TEXT';
        CF_BITMAP		: Result := 'CF_BITMAP';
        CF_METAFILEPICT	: Result := 'CF_METAFILEPICT';
        CF_SYLK			: Result := 'CF_SYLK';
        CF_DIF			: Result := 'CF_DIF';
        CF_TIFF			: Result := 'CF_TIFF';
        CF_OEMTEXT		: Result := 'CF_OEMTEXT';
        CF_DIB			: Result := 'CF_DIB';
        CF_PALETTE		: Result := 'CF_PALETTE';
        CF_PENDATA		: Result := 'CF_PENDATA';
        CF_RIFF			: Result := 'CF_RIFF';
        CF_WAVE			: Result := 'CF_WAVE';
        CF_UNICODETEXT	: Result := 'CF_UNICODETEXT';
        CF_ENHMETAFILE	: Result := 'CF_ENHMETAFILE';
        CF_HDROP		: Result := 'CF_HDROP';
        CF_LOCALE		: Result := 'CF_LOCALE';
        CF_MAX			: Result := 'CF_MAX';
        CF_OWNERDISPLAY	: Result := 'CF_OWNERDISPLAY';
        CF_DSPTEXT		: Result := 'CF_DSPTEXT';
        CF_DSPBITMAP	: Result := 'CF_DSPBITMAP';
        CF_DSPMETAFILEPICT	: Result := 'CF_DSPMETAFILEPICT';
        CF_DSPENHMETAFILE	: Result := 'CF_DSPENHMETAFILE';
        CF_PRIVATEFIRST	: Result := 'CF_PRIVATEFIRST';
        CF_PRIVATELAST	: Result := 'CF_PRIVATELAST';
        CF_GDIOBJFIRST	: Result := 'CF_GDIOBJFIRST';
        CF_GDIOBJLAST	: Result := 'CF_GDIOBJLAST';
    else
    	Result := IntToStr(Value);
    end;
end;

(*
    ############################################################################

    TClipWatcher

    ############################################################################
*)

(*
    =======================================================
    RXgN^
    =======================================================
*)
constructor TClipWatcher.Create(Proc: TClipUpdatedNotify);
begin
    inherited Create;

    // 
    IsFirst := True;

    // EBhERg[̂ӂ
    WndHandle := AllocateHWnd(WndProc);
    // ̃Nbv{[hr[Ãnh
    HClipNext := INVALID_HANDLE_VALUE;
    // ʒm֐󂯎
    ClipProc := Proc;
    // Nbv{[hr[AƂēo^
    ClipboardSetHandle;

    // 
    IsFirst := False;

end;

(*
    =======================================================
    fXgN^
    =======================================================
*)
destructor  TClipWatcher.Destroy();
begin
    // Nbv{[hr[AƂėE
    ClipboardReleaseHandle;
    // EBhÊӂ蒆~
    DeallocateHWnd(WndHandle);
    inherited Destroy;
end;

(*
    =======================================================
    Nbv{[hĎ̂߂̏
    =======================================================
*)
procedure    TClipWatcher.ClipboardSetHandle;
begin
    // ܂̂̏ĂȂȂ
    if HClipNext = INVALID_HANDLE_VALUE then
    begin
        // Nbv{[hr[AƂēo^Ă݂
        HClipNext := SetClipboardViewer(WndHandle);
        // ߂Ȃ
        if HClipNext = INVALID_HANDLE_VALUE then
            // O
            if GetLastError <> 0 then
                raise Exception.Create(SysErrorMessage(GetLastError));
    end;
end;

(*
    =======================================================
    Nbv{[hĎ̔j
    =======================================================
*)
procedure    TClipWatcher.ClipboardReleaseHandle;
begin
    // Nbv{[hr[AƂēo^łĂȂ
    if HClipNext <> INVALID_HANDLE_VALUE then
    begin
        // ̓zɁuv
        ChangeClipboardChain(WndHandle, HClipNext);
        // ̓z̃nhYp
        HClipNext := INVALID_HANDLE_VALUE;
    end;
end;

(*
    =======================================================
    bZ[W󂯎
    =======================================================
*)
procedure   TClipWatcher.WndProc(var Msg: TMessage);
var
    WmDrawClip: TWMDrawClipboard;
    WmChangeCB: TWMChangeCBChain;
begin
    case Msg.Msg of

    // Nbv{[hXVtbN
    WM_DRAWCLIPBOARD:
        begin

            // \̂̃o悭킩Ȃ̂ŁALXgĂ݂
            WmDrawClip := TWMDrawClipboard(Msg);

            //ʒm
            if not IsFirst then ClipProc();

            //̐lɂĂ
            if HClipNext <> INVALID_HANDLE_VALUE then
            begin
                SendMessage(HClipNext, WM_DRAWCLIPBOARD, 0, 0);
            end;

        end;

    // ɂ܂킷
    WM_CHANGECBCHAIN:
        begin

            // \̂̃o悭킩Ȃ̂ŁALXgĂ݂
            WmChangeCB := TWMChangeCBChain(Msg);

            if WmChangeCB.Remove = HClipNext then
            begin
                HClipNext := WmChangeCB.Next;
            end;
            if HClipNext <> INVALID_HANDLE_VALUE then
            begin
                SendMessage(HClipNext, WM_CHANGECBCHAIN, WmChangeCB.Remove, WmChangeCB.Next);
            end;

        end;

    // ȊÔׂ
    else
        begin

            Msg.Result := DefWindowProc(WndHandle, Msg.Msg, Msg.wParam, Msg.lParam);

        end;

    end;
end;

(*
    ############################################################################

    TPasteWatcher

    ############################################################################
*)

const
	WM_POSTRENDER = WM_USER + 100;

(*
    =======================================================
    RXgN^
    =======================================================
*)
constructor TPasteWatcher.Create(Proc: TDerayRenderer);
begin
    inherited Create;

    // ʒm֐󂯎
    RenderProc := Proc;
    // EBhERg[̂ӂ
    WndHandle := AllocateHWnd(WndProc);

end;

(*
    =======================================================
    fXgN^
    =======================================================
*)
destructor  TPasteWatcher.Destroy();
begin
    // EBhÊӂ蒆~
    DeallocateHWnd(WndHandle);
    inherited Destroy;
end;

(*
	=======================================================
    x_Os߂̏
	=======================================================
*)
procedure	TPasteWatcher.SetRender;
begin
    OpenClipboard(WndHandle);
    EmptyClipboard;
    SetClipboardData(CF_TEXT, 0);
    CloseClipboard;
end;

(*
    =======================================================
    bZ[W󂯎
    =======================================================
*)
procedure   TPasteWatcher.WndProc(var Msg: TMessage);
var
    WmRender: TWMRenderFormat;
begin
    case Msg.Msg of

    // \to
    WM_RENDERFORMAT:
        begin

            // \̂̃o悭킩Ȃ̂ŁALXgĂ݂
            WmRender := TWMRenderFormat(Msg);

            // J
            OpenClipboard(WndHandle);
            try
                //@ɂ
                EmptyClipboard;
                // f[^
                RenderProc();
            finally
                // 
                CloseClipboard;
            end;

            // I
            PostMessage(WndHandle, WM_POSTRENDER, 0, 0);
        end;

    // ɔ
    WM_POSTRENDER:
        begin

            Sleep(100);
            SetRender();

        end;

    // ȊÔׂ
    else
        begin

            Msg.Result := DefWindowProc(WndHandle, Msg.Msg, Msg.wParam, Msg.lParam);

        end;

    end;
end;

(*
    =======================================================
    eX.eX.
    =======================================================

procedure   Render();
var
    Txt: String;
    Data: THandle;
    Buff: Pointer;
begin
    Txt := IntToStr(GetTickCount);

    Data := GlobalAlloc(GMEM_MOVEABLE, Length(Txt) + 1);
    Buff := GlobalLock(Data);
    StrCopy(Buff, PChar(Txt));
    SetClipboardData(CF_TEXT, Data);
    GlobalUnlock(Data);
end;

var
    A: TPasteWatcher;

initialization

    A := TPasteWatcher.Create(Render);
    A.SetRender();

finalization

    A.Free;

procedure   ShowMsg();
begin
    if Clipboard.HasFormat(CF_TEXT) then
    begin
        //ACeQbg
        ShowMessage(Clipboard.AsText);
    end;
end;

var
    A: TClipWatcher;

initialization

    A := TClipWatcher.Create(ShowMsg);

finalization

    A.Free;
*)


end.

